//*************************
// Variables
//*************************

$btn-colors: ("danger": #ff3547,
"danger-hover": #e22b3a,
"danger-focus": #c92431,
"danger-color" :#fff,

//
"warning": #ffbb33,
"warning-hover": #FF8800,
"warning-focus": #c76a00,
"warning-color" :#000000,
//
"success": #00C851,
"success-hover": #007E33,
"success-focus": #015e26,
"success-color" :#fff,
//
"info": #33b5e5,
"info-hover": #0099CC,
"info-focus": #00678a,
"info-color" :#fff,
//
"default": #2BBBAD,
"default-hover": #00695c,
"default-focus": #004d44,
"default-color" :#fff,
//
"primary": #4285F4,
"primary-hover": #0d47a1,
"primary-focus": #012b69,
"primary-color" :#fff,
//
"secondary": #aa66cc,
"secondary-hover": #9933CC,
"secondary-focus": #5e1c80,
"secondary-color" :#fff,
//
"elegant": #2E2E2E,
"elegant-hover": #212121,
"elegant-focus": #333333,
"elegant-color" :#fff,
//
"stylish": #4B515D,
"stylish-hover": #3E4551,
"stylish-focus": #2f353f,
"stylish-color" :#fff,
//
"unique": #3F729B,
"unique-hover": #1C2331,
"unique-focus": #141922,
"unique-color" :#fff,
//
"light": #f8f9fa,
"light-hover": #e2e6ea,
"light-focus": #dae0e5,
"light-color" :#212529,
//
"dark": #343a40,
"dark-hover": #23272b,
"dark-focus": #1d2124,
"dark-color" :#fff,
);

*[disabled] {
   color: red;
}

$btn-names: ("danger",
//
"warning",
//
"success",
//
"info",
//
"default",
//
"primary",
//
"secondary",
//
"elegant",
//
"stylish",
//
"unique",
//
"light",
//
"dark",
);

//*************************
// Classes
//*************************


.btn,
button {
   display: inline-block;
   font-weight: 400;
   color: #212529;
   text-align: center;
   vertical-align: middle;
   -webkit-user-select: none;
   -moz-user-select: none;
   -ms-user-select: none;
   user-select: none;
   background-color: transparent;
   border: 1px solid transparent;
   padding: 7px 12px;
   cursor: pointer;
   font-size: 1rem;
   line-height: 1.25;
   border-radius: 0.25rem;
   transition: 0.2s ease-in;
   white-space: nowrap;

   &.disabled,
   &:disabled,
   &[disabled] {
      opacity: .65;
   }
}

@media (prefers-reduced-motion: reduce) {
   .btn {
      transition: none;
   }
}

.btn-label {
   background: rgba(0, 0, 0, .05);
   margin: -9px 11px -9px -13px;
   padding: 7px 11px 7px 14px;
}

@if $env=='elite' {
   .btn-rounded {
      @include all-border-radius(100px);
      padding: 7px 18px;
   }

   .btn-square {
      @include all-border-radius(0px);
   }

   .btn-xs {
      padding: .25rem .5rem;
      font-size: 10px;
   }
}

.btn-sm {
   padding: .25rem .5rem;
   font-size: 12px;
   line-height: 1.5;
}

.btn-lg {
   padding: .75rem 1.5rem;
   font-size: 1.25rem;
   line-height: 1.5;
}

@each $color in $btn-names {
   .btn-#{$color} {
      color: map-get($btn-colors, $color+"-color");
      background-color: map-get($btn-colors, $color);
      border-color: map-get($btn-colors, $color);

      &.shadow:not(:disabled):not(.disabled):not([disabled]) {
         box-shadow: 0 2px 2px 0 rgba(map-get($btn-colors, $color+'-hover'), 0.14), 0 3px 1px -2px rgba(map-get($btn-colors, $color+'-hover'), 0.2), 0 1px 5px 0 rgba(map-get($btn-colors, $color+'-hover'), 0.12);
      }

      &.outline {
         background-color: white;
         border-width: 2px;
         color: map-get($btn-colors, $color);

         &:hover {
            color: map-get($btn-colors, $color+"-color");
            background-color: map-get($btn-colors, $color);
            border-color: map-get($btn-colors, $color);
         }
      }
   }

   .btn-#{$color}:hover:not([disabled]) {
      color: map-get($btn-colors, $color+"-color");
      background-color: map-get($btn-colors, $color+"-hover");
      border-color: map-get($btn-colors, $color+"-hover");

      &.shadow:not(:disabled):not(.disabled):not([disabled]) {
         box-shadow: 0 14px 26px -12px rgba(map-get($btn-colors, $color+"-hover"), 0.42), 0 4px 23px 0 rgba(0, 0, 0, 0.12), 0 8px 10px -5px rgba(map-get($btn-colors, $color+"-hover"), 0.2);
      }
   }

   .btn-#{$color}:not([disabled]):focus,
   .btn-#{$color}:not([disabled]).focus {
      box-shadow: 0 0 0 0.2rem rgba(map-get($btn-colors, $color+"-focus"), 0.5);
   }

   .btn-#{$color}.disabled,
   .btn-#{$color}:disabled {
      color: map-get($btn-colors, $color+"-color");
      background-color: map-get($btn-colors, $color);
      border-color: map-get($btn-colors, $color);
   }

   .btn-#{$color}:not(:disabled):not(.disabled):not([disabled]):active,
   .btn-#{$color}:not(:disabled):not(.disabled):not([disabled]).active,
   .show>.btn-#{$color}.dropdown-toggle {
      color: map-get($btn-colors, $color+"-color");
      background-color: map-get($btn-colors, $color+"-focus");
      border-color: map-get($btn-colors, $color+"-focus");
   }

   .btn-#{$color}:not(:disabled):not(.disabled):not([disabled]):active:focus,
   .btn-#{$color}:not(:disabled):not(.disabled):not([disabled]).active:focus,
   .show>.btn-#{$color}.dropdown-toggle:focus {
      box-shadow: 0 0 0 0.2rem rgba(map-get($btn-colors, $color+"-focus"), 0.5);
   }
}